#include"audio.hpp"




namespace audio{


Player::
Player(const Wave&  wave, int  count):
wave_(wave),
position_(0),
count_(count)
{
}




bool
Player::
mix(int16_t*  dst, int  len)
{
  const int  wave_length = wave_.get_length();

RESTART:
  const int  remain = (wave_length-position_);

  int  n = std::min(count_,std::min(remain,len));

  const int16_t*  src = &wave_.get_sample(position_);

  position_ += n;
  len       -= n;
  count_    -= n;

    while(n--)
    {
      *dst++ += *src++;
    }


    if(position_ >= wave_length)
    {
      position_ = 0;
    }


    if(!count_)
    {
      return false;
    }


    if(len)
    {
      goto RESTART;
    }


  return true;
}


void
Player::
set_status(Status  status)
{
  status_ = status;
}


Player::Status
Player::
get_status() const
{
  return status_;
}




}




