#include"base64.hpp"




namespace{


const char
table[64] =
{
'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
'0','1','2','3','4','5','6','7','8','9','+','/'
};


int
geti(int  c)
{
    for(int  i = 0;  i < 64;  ++i)
    {
        if(table[i] == c)
        {
          return i;
        }
    }


  return 0;
}


}


std::string
encode_base64(const void*  ptr, size_t  length)
{
  std::string  s;

  auto  p = (const uint8_t*)ptr;

  uint32_t  t24;

    while(length)
    {
      t24 = 0;

        for(int  n = 3;  n--;)
        {
          t24 <<= 8;

            if(length)
            {
              t24 |= *p++;

              --length;
            }
        }


      s += table[(t24>>18)     ];
      s += table[(t24>>12)&0x3F];
      s += table[(t24>> 6)&0x3F];
      s += table[(t24    )&0x3F];
    }


  return std::move(s);
}


std::string
decode_base64(const std::string&  s)
{
  std::string  buf;

  auto  p = s.data();

  size_t  length = s.size();

  uint32_t  t24;

    while(length)
    {
      t24 = 0;

        for(int  n = 4;  n--;)
        {
          t24 <<= 6;

            if(length)
            {
              t24 |= geti(*p++);

              --length;
            }
        }


      buf.push_back((t24>>16)     );
      buf.push_back((t24>> 8)&0xFF);
      buf.push_back((t24    )&0xFF);
    }


  return std::move(buf);
}




