#include"block.hpp"




Block::
Block()
{
}




void
Block::
update()
{
}




void
Block::
draw(PixelMap16&  pixmap, int  x, int  y) const
{
  const auto  n = side_length*2;

  transfer(cube::pixelmap_,0,0,n,n,pixmap,x,y);
}


void
Block::
draw(Drawer&  dr, int  x, int  y) const
{
  const auto  n = side_length*2;

/*
    switch(type_)
    {
      case(Type::plain):
        transfer(cube::pixelmap_,0,0,n,n,dr,x,y);

          rep(i,Dir::END)
          {
            auto  dir = (Dir)i;

              if(!area_->get_object(dir))
              {
                cube::draw_frame(dr,x,y,dir);
              }
          }
        break;
      case(Type::colored):
        cube::fill_top_plane(  dr,palette->entries[status_.top_color_index  ].pixel,x,y);
        cube::fill_front_plane(dr,palette->entries[status_.front_color_index].pixel,x,y);
        cube::fill_right_plane(dr,palette->entries[status_.right_color_index].pixel,x,y);

          rep(i,Dir::END)
          {
            auto  dir = (Dir)i;

              if(!area_->get_object(dir))
              {
                cube::draw_frame(dr,x,y,dir);
              }
          }
        break;
    }
*/
}




using namespace krtdb;


const TableDef
Block::
tabledef({Header("point.x",ValueKind::uint16_),
          Header("point.y",ValueKind::uint16_),
          Header("point.z",ValueKind::uint16_),
          Header("step_counter",ValueKind::uint16_),
          Header("step_counter_source",ValueKind::uint16_),
          Header("blink_state",ValueKind::uint8_),
          Header("blink_counter",ValueKind::uint8_),
          Header("move_counter",ValueKind::uint16_),
          Header("move_dir",ValueKind::uint8_),
          Header("bubble_counter",ValueKind::uint8_),

          Header("visible",ValueKind::bool_),
          Header("supervisible",ValueKind::bool_),
          Header("float",ValueKind::bool_),
          Header("hard",ValueKind::bool_),
          Header("block",ValueKind::bool_),
          Header("move",ValueKind::bool_),
          Header("super",ValueKind::bool_),
          Header("fixed",ValueKind::bool_),
          });


void
Block::
load(const Record&  rec, const Storage&  sto)
{
  auto  src = rec.values_.data();

  auto&  figure_table = sto.get_table("figures");

    /*object*/
    {
      point_.x = src++->u_;
      point_.y = src++->u_;
      point_.z = src++->u_;


      step_counter_        = src++->u_;
      step_counter_source_ = src++->u_;
      blink_state_         = src++->u_;
      blink_counter_       = src++->u_;
      move_counter_        = src++->u_;
      move_dir_            = (Dir)src++->u_;
      bubble_counter_      = src++->u_;

      flags_ = 0;

        if(src++->u_){set_flag(visible_flag     );}
        if(src++->u_){set_flag(supervisible_flag);}
        if(src++->u_){set_flag(float_flag       );}
        if(src++->u_){set_flag(hard_flag        );}
        if(src++->u_){set_flag(block_flag       );}
        if(src++->u_){set_flag(move_flag        );}
        if(src++->u_){set_flag(super_flag       );}
        if(src++->u_){set_flag(fixed_flag       );}
    }


//  figure_.load(figure_table.get_record(src++->u_));
}


void
Block::
save(Record&  rec, Storage&  sto) const
{
  auto  dst = rec.values_.data();

  auto&  figure_table = sto.get_table("figures");

    /*object*/
    {
      *dst++ = Value(point_.x);
      *dst++ = Value(point_.y);
      *dst++ = Value(point_.z);

      *dst++ = Value(step_counter_);
      *dst++ = Value(step_counter_source_);
      *dst++ = Value(blink_state_);
      *dst++ = Value(blink_counter_);
      *dst++ = Value(move_counter_);
      *dst++ = Value((int)move_dir_);
      *dst++ = Value(bubble_counter_);

      *dst++ = Value(test_flag(visible_flag     ));
      *dst++ = Value(test_flag(supervisible_flag));
      *dst++ = Value(test_flag(float_flag       ));
      *dst++ = Value(test_flag(hard_flag        ));
      *dst++ = Value(test_flag(block_flag       ));
      *dst++ = Value(test_flag(move_flag        ));
      *dst++ = Value(test_flag(super_flag       ));
      *dst++ = Value(test_flag(fixed_flag       ));
    }


/*
  auto&  figrec = figure_table.new_record();

  figure_.save(figrec);

  *dst++ = Value(figrec.get_pointer().record_number_);
*/
}





