#include"cube.hpp"
#include"rep.hpp"



namespace cube{




template<typename  T, typename  U>
void
fill_top_plane_(T&  dst, U  pixel, int  x, int  y)
{
  y += (side_length/2)-1;

  dst.draw_hline(pixel,x,y,(side_length*2));


  int  xx = x+2;
  int  yy = y-1;

  int  w = (side_length*2)-4;
  int  n = (side_length/2)-1;

    while(n--)
    {
      dst.draw_hline(pixel,xx,yy,w);

      xx += 2;
      yy -= 1;
       w -= 4;
    }


  ++x;
  ++y;

  w = (side_length*2)-2;
  n = (side_length/2);

    while(n--)
    {
      dst.draw_hline(pixel,x,y,w);

      x += 2;
      y += 1;
      w -= 4;
    }
}


template<typename  T, typename  U>
void
fill_front_plane_(T&  dst, U  pixel, int  x, int  y)
{
  int  h = side_length;

  y += (side_length/2);

  dst.draw_vline(pixel,x,y,h);

  x += 1;
  y += 1;

  int  n = ((side_length/2)-1);

    while(n--)
    {
      dst.draw_vline(pixel,x++,y  ,h);
      dst.draw_vline(pixel,x++,y++,h);
    }


  dst.draw_vline(pixel,x,y,h);
}


template<typename  T, typename  U>
void
fill_right_plane_(T&  dst, U  pixel, int  x, int  y)
{
  int  h = side_length;

  x += side_length;
  y += side_length;

  dst.draw_vline(pixel,x,y,h);

  x += 1;
  y -= 1;

  int  n = (side_length/2)-1;

    while(n--)
    {
      dst.draw_vline(pixel,x++,y  ,h);
      dst.draw_vline(pixel,x++,y--,h);
    }


  dst.draw_vline(pixel,x,y,h);
}




void    fill_top_plane(PixelMap16&  dst, pixel16_t  pixel, int  x, int  y){  fill_top_plane_(dst,pixel,x,y);}
void  fill_front_plane(PixelMap16&  dst, pixel16_t  pixel, int  x, int  y){fill_front_plane_(dst,pixel,x,y);}
void  fill_right_plane(PixelMap16&  dst, pixel16_t  pixel, int  x, int  y){fill_right_plane_(dst,pixel,x,y);}

void    fill_top_plane(Drawer&  dst, pixel16_t  pixel, int  x, int  y){  fill_top_plane_(dst,to_pixel32(pixel),x,y);}
void  fill_front_plane(Drawer&  dst, pixel16_t  pixel, int  x, int  y){fill_front_plane_(dst,to_pixel32(pixel),x,y);}
void  fill_right_plane(Drawer&  dst, pixel16_t  pixel, int  x, int  y){fill_right_plane_(dst,to_pixel32(pixel),x,y);}




}





