#include"fileio.hpp"
#include"rep.hpp"
#include<cstdio>
#include<zlib.h>




void
save_file(const void*  src_data, size_t  src_size, const char*  path, bool  backup)
{
/*
    if(backup)
    {
      auto  src = fopen(path,"rb");

        if(src)
        {
          char  dst_path[256];

          snprintf(dst_path,sizeof(dst_path),"%s.bak",path);

          fclose(src);
        }
    }
*/


  FILE*  f = fopen(path,"wb");

    if(!f)
    {
      report;
      return;
    }


    if(fwrite(src_data,1,src_size,f) != src_size)
    {
      report;
    }


  fclose(f);
}



void
save_gzfile(const void*  src_data, size_t  src_size, const char*  path, bool  backup)
{
  gzFile  gz = gzopen(path,"wb9");

    if(!gz)
    {
      report;
      return;
    }


    if(gzwrite(gz,(const unsigned char*)src_data,src_size) != src_size)
    {
      report;
    }


  gzclose(gz);
}



std::string
load_file(const char*  path)
{
  std::string  s;

  auto  f = fopen(path,"rb");

    if(f)
    {
        for(;;)
        {
          const int  c = fgetc(f);

            if(feof(f))
            {
              break;
            }


          s.push_back(c);
        }


      fclose(f);
    }


  return std::move(s);
}


std::string
load_gzfile(const char*  path)
{
  std::string  s;

  gzFile  gz = gzopen(path,"rb");

    if(!gz)
    {
      return load_file(path);
    }


  
    for(;;)
    {
      const int  c = gzgetc(gz);

        if(gzeof(gz))
        {
          break;
        }


      s.push_back(c);
    }


  gzclose(gz);

  return std::move(s);
}




