#include"impr.hpp"




const Point3D&  Area::operator *() const{return  point_;}
const Point3D*  Area::operator->() const{return &point_;}


const Point3D&  Area::get_point() const{return  point_;}


void
Area::
set_point(int  x, int  y, int  z)
{
  point_.x = side_length*x;
  point_.y = side_length*y;
  point_.z = side_length*z;
}


Area*
Area::
get_adjoining_area(Dir  dir) const
{
  return adjoining_areas[(int)dir];
}


void
Area::
set_adjoining_area(Dir  dir, Area*  area)
{
  adjoining_areas[(int)dir] = area;
}




Object*
Area::
get_object() const
{
  return object_;
}


Object*
Area::
get_object(Dir  dir) const
{
  auto  ar = get_adjoining_area(dir);

  return(ar? ar->object_:nullptr);
}


void
Area::
set_object(Object*  obj)
{
  object_ = obj;
}




void
Area::
wake_upper(Space&  space)
{
  auto  upper = get_adjoining_area(Dir::top);

    while(upper && upper->get_object())
    {
      space.insert_object(upper->get_object());

      upper = upper->get_adjoining_area(Dir::top);
    }
}




void
Area::
update_around_object(const Space&  space) const
{
  auto     top = get_object(Dir::top);
  auto  bottom = get_object(Dir::bottom);
  auto   front = get_object(Dir::front);
  auto    back = get_object(Dir::back);
  auto    left = get_object(Dir::left);
  auto   right = get_object(Dir::right);

    if(   top){space.callback_(   top,Space::Signal::update);}
    if(bottom){space.callback_(bottom,Space::Signal::update);}
    if( front){space.callback_( front,Space::Signal::update);}
    if(  back){space.callback_(  back,Space::Signal::update);}
    if(  left){space.callback_(  left,Space::Signal::update);}
    if( right){space.callback_( right,Space::Signal::update);}
}



bool
Area::
start_move_object(Dir  dir_id, Space&  space, int  pushing_power)
{
    if(!object_ || object_->get_move_counter())
    {
      return false;
    } 


  auto  dst = get_adjoining_area(dir_id);

    if(!dst)
    {
      return false;
    }


    if(dst->get_object())
    {
        if(dst->get_object()->get_move_counter())
        {
          return false;
        }

      else
        if(pushing_power > 0)
        {
            if(!dst->get_adjoining_area(dir_id))
            {
              space.release_object(dst->get_object());
            }


            if(!dst->start_move_object(dir_id,space,pushing_power-1))
            {
              return false;
            }
        }

      else
        {
          return false;
        }
    }


  dst->set_object(object_)              ;
                  object_->set_area(dst);

  object_ = nullptr;

  update_around_object(space);


  auto  dst_obj = dst->get_object();

  space.insert_object(dst_obj);

  int  n = side_length;

    switch(dir_id)
    {
      case(Dir::left):
        wake_upper(space);

        dst_obj->set_move(dir_id,n);
        break;
      case(Dir::right):
        wake_upper(space);

        dst_obj->set_move(dir_id,n);
        break;
      case(Dir::front):
        wake_upper(space);

        dst_obj->set_move(dir_id,n);
        break;
      case(Dir::back):
        wake_upper(space);

        dst_obj->set_move(dir_id,n);
        break;
      case(Dir::top):
        dst_obj->set_move(dir_id,n,500);
        break;
      case(Dir::bottom):
        wake_upper(space);

        dst_obj->set_move(dir_id,n,2000);
        break;
      default:;
    }


  return true;
}


bool
Area::
try_fall_object(Space&  space)
{
    if(object_ && !object_->get_move_counter() && !object_->test_flag(Object::float_flag))
    {
      auto  bottom = get_adjoining_area(Dir::bottom);

        if(bottom && !bottom->get_object())
        {
          start_move_object(Dir::bottom,space,0);

          return true;
        }
    }


  return false;
}




