#ifndef IMPR_AREA_HPP_INCLUDED
#define IMPR_AREA_HPP_INCLUDED


#include"impr_point.hpp"


class Space;
class Object;


enum
class Dir
{
    left,
   right,
   front,
    back,
     top,
  bottom,

  END,

  none,
  unknown,
  invalid,

};


class Area;


constexpr int  side_length = 16;


class
Area
{
  Object*  object_;

  Point3D  point_;

  Area*  adjoining_areas[(int)Dir::END];

  uint32_t  flags_;

public:
  const Point3D&  operator *() const;
  const Point3D*  operator->() const;

  const Point3D&  get_point() const;

  void  set_point(int  x, int  y, int  z);

  void  wake_upper(Space&  space);

  Area*  get_adjoining_area(Dir  dir             ) const;
  void   set_adjoining_area(Dir  dir, Area*  area)      ;

  Object*  get_object(        ) const;
  Object*  get_object(Dir  dir) const;

  void  set_object(Object*  obj);


  void  update_around_object(const Space&  space) const;

  bool  start_move_object(Dir  dir_id, Space&  space, int  pushing_power=0);

  bool  try_fall_object(Space&  space);

};




#endif




