#include"impr.hpp"
#include<cstring>




int
Object::
default_step_counter_source = 0x2400;


Object::
Object()
{
  clear();
}


Object::
~Object()
{
}




void
Object::
clear()
{
  area_ = nullptr;

  flags_ = visible_flag;

  step_counter_source_  = default_step_counter_source;
  step_counter_         = 0;

  blink_state_   = BlinkState::off;
  blink_counter_ = 0;

  bubble_counter_ = 0;

  move_counter_ = 0;
  move_dir_     = Dir::none;
}




void                Object::set_blink_state(BlinkState  state)      {blink_state_ = state;}
Object::BlinkState  Object::get_blink_state(                 ) const{return (BlinkState)blink_state_;}


int  Object::get_move_counter() const{return move_counter_;}
Dir  Object::get_move_dir() const{return move_dir_;}

void
Object::
set_move(Dir  dir, int  n, int  rate)
{
  move_dir_     = dir;
  move_counter_ =   n;

  step_counter_source_ = (default_step_counter_source*rate/1000);
}


uint8_t
Object::
test_bubbly() const
{
  return bubble_counter_;
}


bool
Object::
test_visible() const
{
    if(test_flag(visible_flag))
    {
      return !(blink_state_&1);
    }


  return false;
}


bool
Object::
test_landing() const
{
    if(!test_flag(float_flag))
    {
      auto  bottom_area = area_->get_adjoining_area(Dir::bottom);

        if(bottom_area)
        {
          auto  bottom_object = bottom_area->get_object();

            if(bottom_object)
            {
              return true;
            }
        }

      else
        {
          return true;
        }
    }


  return false;
}




const Point3D&  Object::get_point() const{return point_;}


void         Object::set_key(Key  key)      {       key_ = key;}
Object::Key  Object::get_key(        )const {return key_      ;}


void
Object::
reset_area(Area&  area)
{
  area_ = &area                 ;
           area.set_object(this);

  point_ = area.get_point();
}


Area*  Object::get_area(           ) const{return area_       ;}
void   Object::set_area(Area*  area)      {       area_ = area;}


void  Object::set_flag  (uint  flag){flags_ |=  flag;}
void  Object::unset_flag(uint  flag){flags_ &= ~flag;}
bool  Object::test_flag (uint  flag) const{return(flags_&flag);}


void
Object::
reset_bubble(uint8_t  t)
{
  bubble_counter_ = t;
}





