#ifndef IMPR_OBJECT_HPP_INCLUDED
#define IMPR_OBJECT_HPP_INCLUDED


#include<list>
#include"impr_area.hpp"




class Area;
class Space;


class
Object
{
public:
  enum
  {
         visible_flag=0x001,
    supervisible_flag=0x002,
           super_flag=0x004,
           fixed_flag=0x008,
            move_flag=0x010,
           block_flag=0x020,
            hard_flag=0x080,
           float_flag=0x100,

       eraseme_flag=0x4000,
      releaseme_flag=0x8000,
  };


  using Key = std::list<Object*>::iterator;
  using uint = unsigned int;


  enum BlinkState{
    off        ,
    level1_hide,
    level1_show,
    level2_hide,
    level2_show,
    level3_hide,
    level3_show,
    level4_hide,
    level4_show,
  };


protected:
  static int  default_step_counter_source;


  Area*  area_;

  Point3D  point_;

  uint16_t  flags_;

  uint16_t  step_counter_       ;
  uint16_t  step_counter_source_;

  uint8_t  blink_state_;
  uint8_t  blink_counter_;

  uint16_t  move_counter_;

  Dir  move_dir_;

  uint8_t   bubble_counter_;

  Key  key_;


  void  change_blink_show(int  time);
  void  change_blink_hide(int  time);

  bool  check_around_float() const;

   Object();
  ~Object();

public:
  void  clear();

  const Point3D&  get_point() const;

  bool  test_visible() const;

  void  process(Space&  space);

  void  step(Space&  space);

  void   move_left(Space&  space);
  void  move_right(Space&  space);
  void  move_front(Space&  space);
  void   move_back(Space&  space);
  void     move_up(Space&  space);
  void   move_down(Space&  space);


  void  reset_area(Area&  area);

  Area*  get_area(           ) const;
  void   set_area(Area*  area)      ;

  void  set_key(Key  key)      ;
  Key   get_key(        ) const;

  uint8_t  test_bubbly() const;

  void        set_blink_state(BlinkState  state)      ;
  BlinkState  get_blink_state(                 ) const;

  int  get_move_counter() const;
  Dir  get_move_dir() const;

  void  set_move(Dir  dir, int  n, int  rate=1000);

  bool  test_landing() const;

  void    set_flag(uint  flag);
  void  unset_flag(uint  flag);
  bool   test_flag(uint  flag) const;

  void  reset_bubble(uint8_t  t=255);

};




#endif




