#include"impr.hpp"




void
Object::
change_blink_show(int  time)
{
  if(blink_counter_ >= time)
  {
    blink_state_ |=  1;
    blink_counter_ = 0;
  }
}


void
Object::
change_blink_hide(int  time)
{
    if(blink_counter_ >= time)
    {
      blink_state_ &= ~1;
      blink_counter_ = 0;
    }
}


void
Object::
process(Space&  space)
{
  step_counter_ += step_counter_source_;

    while(step_counter_>>12)
    {
      step(space);

      step_counter_ -= 0x1000;
    }


    if(blink_state_ != BlinkState::off)
    {
      ++blink_counter_;

        switch(blink_state_)
        {
          case(BlinkState::level1_show): change_blink_show(32);break;
          case(BlinkState::level1_hide): change_blink_hide(32);break;
          case(BlinkState::level2_show): change_blink_show(16);break;
          case(BlinkState::level2_hide): change_blink_hide(16);break;
          case(BlinkState::level3_show): change_blink_show( 2);break;
          case(BlinkState::level3_hide): change_blink_hide( 2);break;
          case(BlinkState::level4_show): change_blink_show( 1);break;
          case(BlinkState::level4_hide): change_blink_hide( 1);break;
        }
    }
}


void
Object::
step(Space&  space)
{
    if(move_counter_)
    {
      --move_counter_;

        switch(move_dir_)
        {
          case(Dir::left  ): move_left( space);break;
          case(Dir::right ): move_right(space);break;
          case(Dir::front ): move_front(space);break;
          case(Dir::back  ): move_back( space);break;
          case(Dir::top   ):  move_up(  space);break;
          case(Dir::bottom): move_down( space);break;
        }


      return;
    }


    if(!move_counter_)
    {
      step_counter_source_ = default_step_counter_source;

        if(!test_flag(super_flag) && check_around_float())
        {
          set_flag(float_flag);
        }


        if(!test_flag(float_flag))
        {
          area_->start_move_object(Dir::bottom,space);
        }
    }


    if(bubble_counter_)
    {
      --bubble_counter_;

           if(!bubble_counter_     ){set_flag(releaseme_flag);}
      else if( bubble_counter_ < 20){blink_state_ = BlinkState::level4_show;}
      else if( bubble_counter_ < 60){blink_state_ = BlinkState::level3_show;}
      else if( bubble_counter_ < 80){blink_state_ = BlinkState::level2_show;}
      else                          {blink_state_ = BlinkState::level1_show;}
    }

  else
    if(!move_counter_)
    {
      set_flag(eraseme_flag);
    }
}




bool
Object::
check_around_float() const
{
  auto   left = area_->get_adjoining_area(Dir::left );
  auto  right = area_->get_adjoining_area(Dir::right);
  auto   back = area_->get_adjoining_area(Dir::back );
  auto  front = area_->get_adjoining_area(Dir::front);

  return((left  &&  left->get_object() &&  left->get_object()->test_flag(float_flag)) ||
         (right && right->get_object() && right->get_object()->test_flag(float_flag)) ||
         (back  &&  back->get_object() &&  back->get_object()->test_flag(float_flag)) ||
         (front && front->get_object() && front->get_object()->test_flag(float_flag)));
}




void
Object::
move_left(Space&  space)
{
  --point_.x;

    if(test_flag(super_flag))
    {
      auto&  view_rect = space.get_view_rect();

      int  pos = (view_rect.x+(view_rect.x_width>>2));

        if(point_.x < pos)
        {
          space.move_view_left(1);
        }
    }
}


void
Object::
move_right(Space&  space)
{
  ++point_.x;

    if(test_flag(super_flag))
    {
      auto&  view_rect = space.get_view_rect();

      int  pos = (view_rect.x+(view_rect.x_width>>2));

        if(point_.x >= pos)
        {
          space.move_view_right(1);
        }
    }
}


void
Object::
move_front(Space&  space)
{
  ++point_.y;

    if(test_flag(super_flag))
    {
      auto&  view_rect = space.get_view_rect();

      int  pos = (view_rect.y+(view_rect.y_width>>2));

        if(point_.y >= pos)
        {
          space.move_view_front(1);
        }
    }
}


void
Object::
move_back(Space&  space)
{
  --point_.y;

    if(test_flag(super_flag))
    {
      auto&  view_rect = space.get_view_rect();

      int  pos = (view_rect.y+(view_rect.y_width>>2));

        if(point_.y < pos)
        {
          space.move_view_back(1);
        }
    }
}


void
Object::
move_up(Space&  space)
{
  ++point_.z;

    if(test_flag(super_flag))
    {
      auto&  view_rect = space.get_view_rect();

      int  pos = (view_rect.z+(view_rect.height>>3));

        if(point_.z >= pos)
        {
          space.move_view_top(1);
        }
    }
}


void
Object::
move_down(Space&  space)
{
  --point_.z;

    if(test_flag(super_flag))
    {
      auto&  view_rect = space.get_view_rect();

      int  pos = (view_rect.z+(view_rect.height>>3));

        if(point_.z < pos)
        {
          space.move_view_bottom(1);
        }
    }
}




