#include"impr.hpp"
#include<algorithm>




namespace{
bool
compare(const Shell&  a, const Shell&  b)
{
  return(a.priority_number_ <
         b.priority_number_);
}
}


void
Space::
collect_visible_objects(std::vector<Shell>&  buf) const
{
  const int  scan_x_base = (view_rect.x/side_length);
  const int  scan_y_base = (view_rect.y/side_length);
  const int  scan_z_base = (view_rect.z/side_length);

  Point2D  offset_pt;

  view_rect.convert_isometrically(offset_pt,nullptr);

    rep(z,scan_size_.height ){
    rep(y,scan_size_.y_width){
    rep(x,scan_size_.x_width){
      auto  obj = get(scan_x_base+x,
                      scan_y_base+y,
                      scan_z_base+z).get_object();

        if(obj && obj->test_visible())
        {
          buf.emplace_back(obj,view_parameter.x_offset,view_parameter.y_offset,&view_rect);
        }
    }}}


  std::stable_sort(buf.begin(),buf.end(),&compare);
}




void
Space::
collect_visible_objects_all(std::vector<Shell>&  buf) const
{
    for(auto&  area: areas_)
    {
      auto  obj = area.get_object();

        if(obj && obj->test_visible())
        {
          buf.emplace_back(obj,whole_view_parameter.x_offset,
                               whole_view_parameter.y_offset);
        }
    }


  std::stable_sort(buf.begin(),buf.end(),&compare);
}


void
Space::
collect_objects_all(std::vector<const Object*>&  buf) const
{
    for(auto&  area: areas_)
    {
      auto  obj = area.get_object();
 
        if(obj)
        {
          buf.emplace_back(obj);
        }
    }
}




