#include"krtdb.hpp"


using namespace krtdb;




TableDef
read_headers(const char*  s)
{
  char  buf[256];

  TableDef  def;

  int  n;

    while(sscanf(s,"[%256[^]]]%n",buf,&n) >= 1)
    {
      def.headers_.emplace_back(buf,ValueKind::string);

      s += n;
    }


  return std::move(def);
}


std::vector<std::string>
separate(const char*  s)
{
  char  buf[256];

  std::vector<std::string>  dst;

    while(*s)
    {
      std::string  tmps;

        while(*s)
        {
          const int  c = *s++;

            if((c == '^') ||
               (c == '\n'))
            {
              break;
            }


          tmps.push_back(c);
        }


      dst.emplace_back(std::move(tmps));
    }


  return std::move(dst);
}


void
read_record(Record&  rec, const std::vector<std::string>&  src)
{
  auto  dst = rec.values_.data();

    for(auto&  s: src)
    {
      char  buf[256];

        if(s[0] == '~')
        {
            if(sscanf(s.data(),"~%256[^~]",buf))
            {
              *dst++ = Value(buf);
            }

          else
            {
              *dst++ = Value("");
            }
        }

      else
        {
          *dst++ = Value(s);
        }
    }
}






int
main(int  argc, char**  argv)
{
  Storage  st;

  --argc;
  ++argv;

    while(argc--)
    {
      const char*  path = *argv++;

      auto  f = fopen(path,"rb");

        if(f)
        {
          static char  buf[1024*8];

          fgets(buf,sizeof(buf),f);

          auto&  table = st.new_table(path,read_headers(buf));

            while(fgets(buf,sizeof(buf),f))
            {
              read_record(table.new_record(),separate(buf));
            }


          fclose(f);
        }
    }


  FileStream  fs(fopen("test.db","wb"));

  st.write(fs);

  return 0;
}




