#ifndef KRTDB_RECORD_HPP_INCLUDED
#define KRTDB_RECORD_HPP_INCLUDED


#include"krtdb_value.hpp"
#include"krtdb_tabledef.hpp"


namespace krtdb{


class Table;


struct
Record
{
  Table&  table_;

  UniqueNumber  number_;

  std::vector<Value>  values_;

  Record(Table&  table, UniqueNumber  number, size_t  n);
  Record(Table&  table, UniqueNumber  number, std::initializer_list<Value>  values);
  Record(Table&  table, UniqueNumber  number, Stream&  s);
  Record(Record&&  rhs);


  Pointer  get_pointer() const;

  void  clear();

  void  operator=(std::initializer_list<Value>  values);

  void   read(Stream&  s)      ;
  void  write(Stream&  s) const;

  void  print() const;

};


}




#endif




