#ifndef KRTDB_STORAGE_HPP_INCLUDED
#define KRTDB_STORAGE_HPP_INCLUDED


#include"krtdb_table.hpp"


namespace krtdb{


class
Storage
{
  UniqueNumber  last_table_number_;

  std::unordered_map<UniqueNumber,Table>     tables_;
  std::unordered_map<std::string,Table*>  namelinks_;

public:
  Storage();

  Table&  new_table(std::string&&  name, const TableDef&   def);
  Table&  new_table(std::string&&  name,       TableDef&&  def);

        Table&  get_table(UniqueNumber  n)      ;
  const Table&  get_table(UniqueNumber  n) const;

        Table&  get_table(const std::string&  name)      ;
  const Table&  get_table(const std::string&  name) const;

  bool  test_table(UniqueNumber  n) const;
  bool  test_table(const std::string&  name) const;

  void   read(Stream&  s)      ;
  void  write(Stream&  s) const;

  void  print() const;

};




}




#endif




