#ifndef KRTDB_VALUE_HPP_INCLUDED
#define KRTDB_VALUE_HPP_INCLUDED


#include"krtdb_valuekind.hpp"
#include"krtdb_bytestring.hpp"




namespace krtdb{


using uint = unsigned int;

using UniqueNumber = uint32_t;


struct
Pointer
{
  UniqueNumber   table_number_;
  UniqueNumber  record_number_;

  constexpr Pointer(UniqueNumber  table_number, UniqueNumber  record_number=0):
  table_number_(table_number),
  record_number_(record_number)
  {
  }

};


struct
Value
{
  union{
     int32_t  i_;
    uint32_t  u_;

    ByteString  bs_;

    Pointer  pointer_;
  };


  Value();
  Value( int32_t  i);
  Value(uint32_t  u);
  Value(const char*  s);
  Value(const std::string&  s);
  Value(ByteString  bs);
  Value(const void*  data, size_t  size);
  Value(      void*  data, size_t  size);
  Value(Pointer  pointer);


  void   read(ValueKind  kind, Stream&  s)      ;
  void  write(ValueKind  kind, Stream&  s) const;

  void  print(ValueKind  kind) const;

};




}




#endif




