#include"block_buffer.hpp"
#include"heap.hpp"
#include"player.hpp"
#include"widget.d/flexmenu.hpp"
#include"widget.d/lettermenu.hpp"
#include"widget.d/frame.hpp"
#include"video.d/video.hpp"
#include"audio.d/audio.hpp"




extern
Controller
ctrl;


namespace{


video::Device*
video_device;


int  looping;


void
process_keydown(const SDL_KeyboardEvent&  evt)
{
    switch(evt.keysym.sym)
    {
      case(SDLK_UP   ): ctrl.press(Key::up_flag   );break;
      case(SDLK_LEFT ): ctrl.press(Key::left_flag );break;
      case(SDLK_RIGHT): ctrl.press(Key::right_flag);break;
      case(SDLK_DOWN ): ctrl.press(Key::down_flag );break;

      case(SDLK_RETURN):                  case(SDLK_z): ctrl.press(Key::p_flag);break;
      case(SDLK_RCTRL ):case(SDLK_LCTRL ):case(SDLK_x): ctrl.press(Key::n_flag);break;

      case(SDLK_RSHIFT):case(SDLK_LSHIFT): ctrl.press(Key::shift_flag);break;
      case(SDLK_SPACE):                    ctrl.press(Key::start_flag);break;

      default:
        ctrl.other_key = evt.keysym.sym;
        ctrl.press(Key::other_flag);
    }


}


void
process_keyup(const SDL_KeyboardEvent&  evt)
{
    switch(evt.keysym.sym)
    {
      case(SDLK_UP   ): ctrl.unpress(Key::up_flag   );break;
      case(SDLK_LEFT ): ctrl.unpress(Key::left_flag );break;
      case(SDLK_RIGHT): ctrl.unpress(Key::right_flag);break;
      case(SDLK_DOWN ): ctrl.unpress(Key::down_flag );break;

      case(SDLK_RETURN):                case(SDLK_z): ctrl.unpress(Key::p_flag);break;
      case(SDLK_RCTRL):case(SDLK_LCTRL):case(SDLK_x): ctrl.unpress(Key::n_flag);break;

      case(SDLK_RSHIFT):case(SDLK_LSHIFT): ctrl.unpress(Key::shift_flag);break;
      case(SDLK_SPACE):                    ctrl.unpress(Key::start_flag);break;
      case(SDLK_F5):
//        world->set_flag(World::screenshot_flag);
        break;

      default:
        ctrl.other_key = evt.keysym.sym;
        ctrl.unpress(Key::other_flag);
    }
}


void
process_window(const SDL_WindowEvent&  evt)
{
    switch(evt.event)
    {
      case(SDL_WINDOWEVENT_EXPOSED):
/*
        world->set_flag(World::redraw_flag);
        world->render();
*/
        break;
    }
}


}


void  process(video::Device*  video_device);
void  initialize();


int
main(int  argc, char**  argv)
{
  SDL_Init(0);

  atexit(SDL_Quit);

  video_device = new video::Device("imptool - " __DATE__,32,32,640,480);

  audio::device::open(32000);
  audio::device::set_pause(false);

  looping = true;

  initialize();

  static SDL_Event  evt;

    while(looping)
    {
        while(SDL_PollEvent(&evt))
        {
            switch(evt.type)
            {
              case(SDL_DROPFILE):    SDL_free(evt.drop.file);                break;
              case(SDL_KEYUP):       process_keyup(evt.key);                break;
              case(SDL_KEYDOWN):     process_keydown(evt.key);                break;
              case(SDL_WINDOWEVENT): process_window(evt.window);                break;
              case(SDL_QUIT):        looping = false;                break;
            }
        }


      process(video_device);

      SDL_Delay(20);
    }


  audio::device::close();

  return 0;
}




