#include"palette.hpp"
#include"heap.hpp"
#include"stream.hpp"




const int  ColorElement::width  = font_size*5;
const int  ColorElement::height = 20;


void
ColorElement::
draw(Drawer&  dr, void*  data, int  item_index, int  x, int  y)
{
  auto&  ent = *static_cast<const ColorEntry*>(data);

    switch(item_index)
    {
      case(0): dr.draw_formatted(0,x,y,"R%d",to_r4(ent.pixel));break;
      case(1): dr.draw_formatted(0,x,y,"G%d",to_g4(ent.pixel));break;
      case(2): dr.draw_formatted(0,x,y,"B%d",to_b4(ent.pixel));break;
    }
}


const int  ColorEntry::width  = 20+40;
const int  ColorEntry::height = 20;


void
ColorEntry::
draw(Drawer&  dr, void*  data, int  item_index, int  x, int  y)
{
  auto&  ent = static_cast<const Palette*>(data)->entries[item_index];

  dr.fill_rect(to_pixel32(ent.pixel),x+2,y+2,18,18);
}





void
Palette::
save(Stream&  s) const
{
    for(auto&  ent: entries)
    {
      s.put_be16(ent.pixel);
    }
}


void
Palette::
load(Stream&  s)
{
    for(auto&  ent: entries)
    {
      ent.pixel = s.get_be16();
    }
}





