#include"player.hpp"
#include"block_buffer.hpp"




Player::
Player():
space_(BlockBuffer::push)
{
  clear();
}




      Space&  Player::get_space()            {return space_;}
const Space&  Player::get_const_space() const{return space_;}




void
Player::
sound(SE  se) const
{
}


void    Player::set_superblock(int  x, int  y, int  z)      {       superblock_ = static_cast<Block*>(space_.get(x,y,z).get_object());}
Block*  Player::get_superblock(                      ) const{return superblock_                                                      ;}


bool
Player::
construct_block(Area*  area, Dir  dir, bool  bubbly)
{
  auto  adjobj = area->get_object(dir);

    if(adjobj)
    {
       if(!adjobj->get_area()->start_move_object(dir,space_,32))
       {
         return false;
       }
    }


    if(area->start_move_object(dir,space_))
    {
      auto  blk = static_cast<Block*>(BlockBuffer::pop());

      blk->reset_area(*area);

      blk->update();

      space_.insert_object(blk);

        if(bubbly)
        {
          blk->reset_bubble(255);
        }


      auto  bottom = area->get_adjoining_area(Dir::bottom);

        if(bottom && bottom->get_object() && bottom->get_object()->test_bubbly())
        {
          blk->set_flag(Object::float_flag);
        }


      return true;
    }


  return false;
}



bool
Player::
destruct_block(Area*  area)
{
    if(area->get_object() && !area->get_object()->get_move_counter())
    {
      auto  bottom = area->get_adjoining_area(Dir::bottom);

        if(bottom)
        {
          auto  btmblk = bottom->get_object();

            if(btmblk)
            {
                if(!btmblk->test_flag(Object::hard_flag))
                {
                  space_.release_object(btmblk);

                  area->start_move_object(Dir::bottom,space_,0);
                }


              return true;
            }
        }
    }


  return false;
}
	



void
Player::
clear()
{
/*
  auto&  area = space_.get(0,0,0);

  superblock_ = static_cast<Block*>(BlockBuffer::pop());

  superblock_->reset_area(area);

  superblock_->set_flag(Object::super_flag);

  superblock_->update();
*/
}


void
Player::
play(Opcode  op)
{
    switch(op)
    {
      case(Opcode::nop):
        break;
      case(Opcode::movl):    superblock_->get_area()->start_move_object(Dir::left ,space_,32);break;
      case(Opcode::movr):    superblock_->get_area()->start_move_object(Dir::right,space_,32);break;
      case(Opcode::movf):    superblock_->get_area()->start_move_object(Dir::front,space_,32);break;
      case(Opcode::movb):    superblock_->get_area()->start_move_object(Dir::back ,space_,32);break;
      case(Opcode::cons):    construct_block(superblock_->get_area(),Dir::top,false);break;
      case(Opcode::consbub): construct_block(superblock_->get_area(),Dir::top, true);break;
      case(Opcode::des):
          if(destruct_block(superblock_->get_area()))
          {
            sound(SE::boo);
          }

        break;
      case(Opcode::movconl): construct_block(superblock_->get_area(),Dir::left ,false);break;
      case(Opcode::movconr): construct_block(superblock_->get_area(),Dir::right,false);break;
      case(Opcode::movconf): construct_block(superblock_->get_area(),Dir::front,false);break;
      case(Opcode::movconb): construct_block(superblock_->get_area(),Dir::back ,false);break;

    }
}


bool
Player::
input(const Controller&  ctrl)
{
    if(ctrl.is_pressing_any())
    {
      auto&  spblk = *superblock_;

        if(spblk.test_landing() && !spblk.get_move_counter())
        {
          const bool  shifted = ctrl.test_pressing(Key::shift_flag);

               if(ctrl.test_pressing(Key::up_flag   )){play(shifted? Opcode::movconb:Opcode::movb);}
          else if(ctrl.test_pressing(Key::left_flag )){play(shifted? Opcode::movconl:Opcode::movl);}
          else if(ctrl.test_pressing(Key::right_flag)){play(shifted? Opcode::movconr:Opcode::movr);}
          else if(ctrl.test_pressing(Key::down_flag )){play(shifted? Opcode::movconf:Opcode::movf);}
          else if(ctrl.test_pressing(Key::p_flag    ))
            {
                if(shifted){play(Opcode::consbub);}
              else         {play(Opcode::cons   );}
            }

          else if(ctrl.test_pressing(Key::n_flag)){play(Opcode::des);}
        }
    }


  space_.move();

  return true;
}




void
Player::
draw_monitor(Drawer&  dr, int  x, int  y) const
{
  auto  text_color = to_pixel32(white_color);

  auto&  area = *superblock_->get_area();

  dr.draw_formatted(text_color,x,y   ,"X:%3d/%3d(%6d)",area->x,space_.get_size().x_width,superblock_->get_point().x/side_length);
  dr.draw_formatted(text_color,x,y+20,"Y:%3d/%3d(%6d)",area->y,space_.get_size().y_width,superblock_->get_point().y/side_length);
  dr.draw_formatted(text_color,x,y+40,"Z:%3d/%3d(%6d)",area->z,space_.get_size().height ,superblock_->get_point().z/side_length);
  dr.draw_formatted(text_color,x,y+60,"stocked blocks %5d",BlockBuffer::size());
  dr.draw_formatted(text_color,x,y+80,"moving objects %5d",space_.get_moving_objects().size());
}




