#ifndef PLAYER_HPP_INCLUDED
#define PLAYER_HPP_INCLUDED


#include"impr_space.hpp"
#include"audio.hpp"
#include"controller.hpp"
#include"block.hpp"




class
Player
{
public:
  enum class Opcode: uint8_t
  {
    nop ,
    movl,
    movr,
    movf,
    movb,
    cons,
    consbub,
    des,

    movconl,
    movconr,
    movconf,
    movconb,

  };


private:
  enum class SE{
    boo,
  };


  Space  space_;

  Block*  superblock_;

  void  sound(SE  se) const;

public:
  Player();


        Space&  get_space()            ;
  const Space&  get_const_space() const;

  void    set_superblock(int  x, int  y, int  z)      ;
  Block*  get_superblock(                      ) const;

  void  clear();

  bool  construct_block(Area*  area, Dir  dir, bool  bubbly);
  bool   destruct_block(Area*  area                        );

  void  play(Opcode  op);

  bool  input(const Controller&  ctrl);

  void  draw_monitor(Drawer&  dr, int  x, int  y) const;

};




#endif




