#include<cstdio>
#include<cstdlib>
#include<cstdint>
#include<cstring>
#include<string>
#include<ft2build.h>
#include FT_FREETYPE_H




namespace{


FT_Library  ftlib;
FT_Face      face;

int  size = 16;


}


#define rep(v,n)  for(int  v = 0;  v < (n);  ++v)


void
render(char16_t  unicode, FILE*  f)
{
    if(FT_Load_Char(face,unicode,0))
    {
      return;
    }


  FT_Render_Glyph(face->glyph,FT_RENDER_MODE_NORMAL);

  auto  slot = face->glyph;

  auto&  bmp = slot->bitmap;

  const int  w = bmp.width;
        int  h =  bmp.rows;

    if(!w || !h)
    {
      return;
    }


  const int  left = slot->bitmap_left;

  auto  p_base = bmp.buffer;

  int  top = ((size/2)-slot->bitmap_top);

    if(top < 0)
    {
      top = 0;
    }


  fprintf(f,"0x%08X,//(w:%d,h:%d,top:%d,left:%d,)\n",unicode,w,h,top,left);


  int  y = 0;

    while(y < top)
    {
      ++y;

      fprintf(f,"0x%08X,\n",0);
    }


    while(h--)
    {
      ++y;

      uint32_t  n = 0;

      uint32_t  flag = 0x80000000>>left;

      auto  p = p_base             ;
                p_base += bmp.pitch;

        rep(x,w)
        {
            if(*p++)
            {
              n |= flag;
            }

          flag >>= 1;
        }


      fprintf(f,"0x%08X,\n",n);
    }


    while(y < size)
    {
      ++y;

      fprintf(f,"0x%08X,\n",0);
    }
}


int
main(int  argc, char**  argv)
{
  const char*  path = nullptr;

  --argc;
  ++argv;

    while(argc--)
    {
      const char*  arg = *argv++;

        if(sscanf(arg,"size=%d",&size) != 1)
        {
          path = arg;
        }
    }


    if(path)
    {
      FT_Init_FreeType(&ftlib);

          if(FT_New_Face(ftlib,path,0,&face) != 0)
          {
            printf("\"%s\" not found.",path);

            return -1;
          }


      FT_Set_Pixel_Sizes(face,size,size);

      auto  f = fopen("output.c","wb");

        if(f)
        {
            for(int  c = ' ';  c <= '~';  ++c)
            {
              render(c,f);
            }


            for(int  c = 0x3000;  c < 0x3100;  ++c)
            {
              render(c,f);
            }


          fclose(f);
        }


      FT_Done_Face(face);
    }


  FT_Done_FreeType(ftlib);

  return 0;
}




