#ifndef VIDEO_DEVICE_HPP_INCLUDED
#define VIDEO_DEVICE_HPP_INCLUDED


#include"drawer.hpp"




namespace video{


class
Device
{
  SDL_Window*      window;
  SDL_Renderer*  renderer;
  SDL_Texture*    texture;

  int  locked;

  int  pitch;

  void*  pixels;

  SDL_Rect  rect;

public:
   Device(const char*  title, int  x, int  y, int  w, int  h);
  ~Device(                                                  );


  void    lock();
  void  unlock();

  bool  test_locked() const;

  int   get_width() const;
  int  get_height() const;

  Drawer  get_drawer();

  void  transfer(Drawer&  src_dr, int  src_x, int  src_y, int  dst_x, int  dst_y);

};


}


#endif




