#ifndef DRAWER_HPP_INCLUDED
#define DRAWER_HPP_INCLUDED


#include"font.hpp"
#include"utf.hpp"
#include"pixel.hpp"
#include"pixelmap.hpp"
#include<SDL.h>
#include<cstring>


class
Drawer: public PixelMap32
{
public:
  Drawer(uint32_t*  pointer, int  w, int  h, int  pitch);
  Drawer(PixelMap32&&  rhs);


  int  draw_unicode(char16_t  c, uint32_t  color, int  x, int  y);

  void  draw_formatted(uint32_t  color, int  x, int  y, const char*  fmt, ...);

  void  draw_ascii(      const char*  s, uint32_t  color, int  x, int  y);
  void  draw_unicode(const char16_t*  s, uint32_t  color, int  x, int  y);


  void  draw_vstripe(uint32_t  color, int  x, int  y, int  length);
  void   draw_stripe(uint32_t  color, int  x, int  y, int  length);

  void  draw_rect(uint32_t  color, int  x, int  y, int  w, int  h);
  void  fill_rect(uint32_t  color, int  x, int  y, int  w, int  h);

  void  subtract(uint8_t  r, uint8_t  g, uint8_t  b, int  x, int  y, int  w, int  h);

  void  save(const char*  path) const;

};




#endif




