#include"drawer.hpp"
#include"font.hpp"




#define rep(v,n)  for(int  v = 0;  v < (n);  v += 1)


int
Drawer::
draw_unicode(char16_t  c, uint32_t  color, int  x, int  y)
{
  auto  p = get_data(c);

    if(p)
    {
      x += 2;
      y += 2;

      auto  it = get_iterator(x,y);

        rep(yy,font_h)
        {
          uint32_t  code = *p++;

          auto  dst = it.get();

            rep(xx,font_w)
            {
                if(code&0x8000)
                {
                  *dst = color;
                }


              code <<= 1;
                dst += 1;
            }
        }


      return font_size;
    }


  return 0;
}




void
Drawer::
draw_ascii(const char*  s, uint32_t  color, int  x, int  y)
{
    while(*s)
    {
      auto  c = *s++;

      x += draw_unicode(c,color,x,y);
    }
}


void
Drawer::
draw_unicode(const char16_t*  s, uint32_t  color, int  x, int  y)
{
    while(*s)
    {
      auto  c = *s++;

      x += draw_unicode(c,color,x,y);
    }
}




void
Drawer::
draw_formatted( uint32_t  color, int  x, int  y, const char*  fmt, ...)
{
  char  buf[256];

  va_list  ap;
  va_start(ap,fmt);

  vsnprintf(buf,sizeof(buf),fmt,ap);

  va_end(ap);

  draw_ascii(buf,color,x,y);
}





