#ifndef PIXEL_HPP_INCLUDED
#define PIXEL_HPP_INCLUDED


#include<cstdint>




using pixel16_t = uint16_t;
using pixel32_t = uint32_t;


constexpr
pixel16_t
to_pixel16(uint8_t  r4, uint8_t  g4, uint8_t  b4)
{
  return(0x1000|(r4<<8)|(g4<<4)|b4);
}


constexpr
pixel16_t
to_mono_pixel16(uint8_t  l4)
{
  return to_pixel16(l4,l4,l4);
}


constexpr int  to_r4(pixel16_t  src){return((src>>8)&15);}
constexpr int  to_g4(pixel16_t  src){return((src>>4)&15);}
constexpr int  to_b4(pixel16_t  src){return((src   )&15);}


void  reset_color_table(uint32_t  pixel_format);

uint32_t  to_pixel32(pixel16_t  pixel);


enum{
  black_color = to_mono_pixel16(0),
  white_color = to_mono_pixel16(15),

  litegray_color = to_mono_pixel16(11),
      gray_color = to_mono_pixel16( 7),
  darkgray_color = to_mono_pixel16( 3),
};






#endif




