#include"video.hpp"




void
transfer(const PixelMap16&  src, int  src_x, int  src_y, int  src_w, int  src_h,
               PixelMap16&  dst, int  dst_x, int  dst_y)
{
  auto  src_it = src.get_const_iterator(src_x,src_y);
  auto  dst_it = dst.get_iterator(      dst_x,dst_y);

    if(!src_w){src_w = src.get_width() ;}
    if(!src_h){src_h = src.get_height();}


    rep(y,src_h)
    {
      auto  src = src_it.get();
      auto  dst = dst_it.get();

        rep(x,src_w)
        {
            if(*src)
            {
              *dst = *src;
            }


          ++src;
          ++dst;
        }
    }
}


namespace{
void
parse(uint16_t  src, uint32_t&  r, uint32_t&  g, uint32_t&  b, uint32_t&  a)
{
    if(src)
    {
      ++a;

      r += ((src>>8)&0xF);
      g += ((src>>4)&0xF);
      b += ((src   )&0xF);
    }
}


void
condense(const std::vector<uint16_t>&  buf, uint16_t&  dst)
{
  dst = 0;

  uint32_t  r = 0;
  uint32_t  g = 0;
  uint32_t  b = 0;
  uint32_t  a = 0;

  const int  n = buf.size();

    if(n)
    {
        for(auto  v: buf)
        {
          parse(v,r,g,b,a);
        }


        if((n/2) < a)
        {
          r /= n;
          g /= n;
          b /= n;

          dst = to_pixel16(r,g,b);
        }
    }
}


}


void
transform(const PixelMap16&  src,
                PixelMap16&  dst)
{
  const int  sample_w = (src.get_width() /dst.get_width() );
  const int  sample_h = (src.get_height()/dst.get_height());

  const int  x_number = (src.get_width() /sample_w);
  const int  y_number = (src.get_height()/sample_h);

  std::vector<uint16_t>  buf;

  buf.reserve(sample_w*sample_h);

    rep(y,y_number){
    rep(x,x_number){
      auto  src_it = src.get_const_iterator(sample_w*x,sample_h*y);

      buf.clear();

        rep(yy,sample_h)
        {
          auto  src_p = src_it.get();

            rep(xx,sample_w)
            {
              buf.emplace_back(*src_p++);
            }
        }


      condense(buf,dst.get_pixel(x,y));
    }}
}


void
transfer(const PixelMap16&  src, int  src_x, int  src_y, int  src_w, int  src_h,
               PixelMap32&  dst, int  dst_x, int  dst_y)
{
  auto  src_it = src.get_const_iterator(src_x,src_y);
  auto  dst_it = dst.get_iterator(      dst_x,dst_y);

    if(!src_w){src_w = src.get_width() ;}
    if(!src_h){src_h = src.get_height();}

    rep(y,src_h)
    {
      auto  src = src_it.get();
      auto  dst = dst_it.get();

        rep(x,src_w)
        {
            if(*src)
            {
              *dst = to_pixel32(*src);
            }


          ++src;
          ++dst;
        }
    }
}





