#ifndef FLEXMENU_HPP
#define FLEXMENU_HPP


#include"widget.hpp"


class
FlexMenu: public Widget
{
public:
  using Callback = void (*)(Drawer&  dr, void*  data, int  item_index, int  x, int  y);

  enum class Action;

private:
  int  page_size_;
  int  page_number_;
  int  page_index_;
  int  position_;

  int  item_width_ ;
  int  item_height_;

  int  area_height_;

  Callback  callback_;

  void*  data_;

  std::vector<const char16_t*>  texts_;

  int  show_cursor_icon_flag_;
  int  show_cursor_frame_flag_;

  void  reset();

  static void  draw_text(Drawer&  dr, void*  data, int  item_index, int  x, int  y);

public:
  FlexMenu(int  page_size, int  page_number, int  item_width, int  item_height, Callback  callback, void*  data=nullptr);
  FlexMenu(std::initializer_list<const char16_t*>  texts);

  void  set_cursor(bool  icon, bool  frame);

  void  reset_item_index();

  int  get_item_index() const;

  void*  get_data() const;
  void   set_data(void*  data);

  Action  process(const Controller&  ctrl);

  void  draw(Drawer&  dr);

};


enum class
FlexMenu::Action
{
  none,
  decide,
  cancel,
  left,
  right,
  up,
  down,
  start,
  change,

};


#endif




