#include"frame.hpp"




Frame::
Frame()
{
}


Frame::
Frame(const std::u16string&  caption, std::initializer_list<Widget*>  widgets, int  margin)
{
  reset(caption,widgets,margin);
}




void
Frame::
reset(const std::u16string&  caption, std::initializer_list<Widget*>  widgets, int  margin)
{
  children.clear();

  caption_ = caption;

  int  x = 8;
  int  y = (font_h+8);

  width  = 8;
  height = 0;

    for(auto  p: widgets)
    {
      insert(p,x,y);

      x += p->width+margin;

      height = std::max(height,p->height);
    }


  height += font_h+8;
  width   = x;

  center_position_ = (width/2)-((font_w*caption_.size())/2);

  cleanup();
}


void
Frame::
draw(Drawer&  dr)
{
  dr.fill_rect(0xFFFFFFFF,point.x,point.y,width,(font_h+8));

  dr.draw_unicode(caption_.data(),0,point.x+center_position_,point.y+4);

  dr.fill_rect(to_pixel32(to_mono_pixel16(10)),point.x,point.y+(font_h+8),width,height-(font_h+8));

    for(auto  p: children)
    {
      p->draw(dr);
    }
}




