#ifndef LETTERMENU_HPP
#define LETTERMENU_HPP


#include"widget.hpp"
#include"textboard.hpp"


class
LetterMenu: public Widget
{
public:
  enum class Action;

  enum class Charset{
    alnum,
    hiragana,
    katakana,

    END
  };

private:
  const char16_t*  table_;

  std::u16string  buffer_;

  Charset  charset_;

  int  x_position_;
  int  y_position_;

  void  change_charset(Charset  set);

  void     up();
  void   down();
  void   left();
  void  right();

public:
  LetterMenu();


  void  reset_buffer(const std::u16string&  s);

  const std::u16string&  get_buffer() const;

  char16_t  get_char(              ) const;
  char16_t  get_char(int  x, int  y) const;

  Action  process(const Controller&  ctrl);

  void  draw(Drawer&  dr);

};


enum class
LetterMenu::
Action
{
  continue_,
  finish,
  cancel,

};


#endif




