#ifndef TEXTBOARD_HPP
#define TEXTBOARD_HPP


#include<string>
#include"widget.hpp"




class
TextBoard: public Widget
{
  std::vector<char16_t>  buffer_;

  std::vector<char16_t*>  lines_;

  int  column_number_;
  int    line_number_;

  struct{
    int  x;
    int  y;
  } cursor_;

public:
  TextBoard();
  TextBoard(int  column_number, int  line_number);


  void  reset(int  column_number, int  line_number);

  void  newline();

  void  backspace();

  void  put(char16_t  c);

  void  copy_string(const char16_t*  src, int  line_index);

  int  get_cursor_x() const;
  int  get_cursor_y() const;

  int  get_column_number() const;
  int  get_line_number() const;

  void  draw(Drawer&  dr);

};


#endif




