#include"widget.hpp"




Widget::
Widget(int  w, int  h, Point  pt):
parent(nullptr),
width(w),
height(h),
style(Style::protrusion),
point(pt)
{
}




void
Widget::
insert(Widget*  child, int  x, int  y)
{
    if(child)
    {
      child->parent = this;

      children.emplace_back(child);

      child->relative_point.x = x;
      child->relative_point.y = y;
    }
}


void
Widget::
cleanup()
{
    if(parent)
    {
      point.x = (parent->point.x+relative_point.x);
      point.y = (parent->point.y+relative_point.y);
    }

  else
    {
      point.x = relative_point.x;
      point.y = relative_point.y;
    }


    for(auto  p: children)
    {
      p->cleanup();
    }
}


void
Widget::
draw(Drawer&  dr)
{
  auto&  pt = point;

  dr.fill_rect(0x00000000,pt.x  ,pt.y  ,width,height);
  dr.fill_rect(0xFFFFFFFF,pt.x+1,pt.y+1,width-2,height-2);

    switch(style)
    {
      case(Style::protrusion):
        dr.draw_stripe(to_pixel32(white_color),pt.x+1,pt.y+1       ,width-2);
        dr.draw_stripe(to_pixel32(black_color),pt.x+1,pt.y+height-2,width-2);

        dr.draw_vstripe(to_pixel32(white_color),pt.x+1      ,pt.y+1,height-2);
        dr.draw_vstripe(to_pixel32(black_color),pt.x+width-2,pt.y+1,height-2);
        break;
      case(Style::hollow):
        dr.draw_stripe(to_pixel32(black_color),pt.x+1,pt.y+1       ,width-2);
        dr.draw_stripe(to_pixel32(white_color),pt.x+1,pt.y+height-2,width-2);

        dr.draw_vstripe(to_pixel32(black_color),pt.x+1      ,pt.y+1,height-2);
        dr.draw_vstripe(to_pixel32(white_color),pt.x+width-2,pt.y+1,height-2);
        break;
      case(Style::flat):
        break;
    }
}




