#include"world.hpp"



struct
World::
EditMenuHandle
{
  static void  decide(const MenuHandler&  handler, void*  userdata);
  static void  cancel(const MenuHandler&  handler, void*  userdata);

};




void
World::EditMenuHandle::
decide(const MenuHandler&  handler, void*  userdata)
{
  auto&  wd = *(World*)userdata;

    switch(handler.get_y_position())
    {
      case(0):
        wd.current_player->update_thumbnail();

        wd.change_mode(Mode::manage);

        wd.pop_menu_handler();
        break;
      default:;
   }
}


void
World::EditMenuHandle::
cancel(const MenuHandler&  handler, void*  userdata)
{
  auto&  wd = *(World*)userdata;

  wd.unset_flag(paused_flag);
}




void
World::
initialize_edit()
{
  edit_menu.reset(new TextMenu({u"終了して、戻る",
                                }));


  edit_menu_handler.reset(*edit_menu,0,0,{std::make_pair(MenuAction::decide,EditMenuHandle::decide),
                                          std::make_pair(MenuAction::cancel,EditMenuHandle::cancel),
                                          },this);

  edit_menu_handler.set_cursor(true);
}


void
World::
reset_edit()
{
  change_mode(World::Mode::edit);

  push_menu_handler(edit_menu_handler);
}


void
World::
render_edit()
{
  auto  dr = video_device_->get_drawer();

  static std::vector<Shell>  shells;

  shells.clear();

  current_player->get_space().collect_visible_objects(shells);

  int  x_base = 160;
  int  y_base =  40;

    for(auto&  sh: shells)
    {
      auto  blk = static_cast<const Block*>(sh.object_);

      blk->draw(dr,x_base+sh.point_.x,y_base+sh.point_.y);
    }


  auto&  view_param = current_player->get_space().get_view_parameter();

  dr.draw_rect(0xFFFFFFFF,x_base,y_base,view_param.width,view_param.height);

    if(test_flag(paused_flag))
    {
      edit_menu_handler.draw(dr);
    }


  current_player->draw_monitor(dr,x_base,y_base+current_player->get_space().get_view_parameter().height);
}




void
World::
input_edit(Controller&  ctrl)
{
    if(test_flag(paused_flag))
    {
        if(test_key_timer(4) && ctrl.is_pressing_any())
        {
               if(ctrl.test_pressing(Key::up_flag   )){get_menu_handler().act(MenuAction::up)   ;}
          else if(ctrl.test_pressing(Key::down_flag )){get_menu_handler().act(MenuAction::down) ;}
          else if(ctrl.test_pressing(Key::left_flag )){get_menu_handler().act(MenuAction::left) ;}
          else if(ctrl.test_pressing(Key::right_flag)){get_menu_handler().act(MenuAction::right);}
          else if(ctrl.test_pressing(Key::p_flag))
            {
              get_menu_handler().act(MenuAction::decide);

              set_flag(keyrest_flag);
            }

          else if(ctrl.test_pressing(Key::n_flag))
            {
              get_menu_handler().act(MenuAction::cancel);

              set_flag(keyrest_flag);
            }

          else
            if(ctrl.test_pressing(Key::start_flag))
            {
              unset_flag(paused_flag);

              set_flag(keyrest_flag);
            }


          set_flag(redraw_flag);
        }
    }

  else
    {
        if(ctrl.test_pressing(Key::start_flag))
        {
            if(test_key_timer(4))
            {
              set_flag(paused_flag);
              set_flag(keyrest_flag);
              set_flag(redraw_flag);
            }
        }

      else
        {
            if(current_player->input(ctrl))
            {
              set_flag(redraw_flag);
            }
        }
    }
}




