#include"world.hpp"




void
World::
initialize_naming()
{
  letter_menu.reset(new LetterMenu);

  name_it_board_.set_string(u"名前を付けてください");

  name_it_board_.set_point(80,20);
     name_board_.set_point(80,60);

  letter_menu->set_point(80,100);
}


void
World::
reset_naming()
{
  auto  name = current_player->get_name().data();

  name_buffer = name;

  name_board_.set_string(name);

  change_mode(Mode::naming);
}




void
World::
render_naming()
{
  auto  dr = video_device_->get_drawer();

  name_it_board_.draw(dr);
  name_board_.draw(dr);

  letter_menu->draw(dr);
}




void
World::
input_naming(Controller&  ctrl)
{
    if(test_key_timer(6) && ctrl.is_pressing_any())
    {
           if(ctrl.test_pressing(Key::up_flag   )){letter_menu->up(   );}
      else if(ctrl.test_pressing(Key::down_flag )){letter_menu->down( );}
           if(ctrl.test_pressing(Key::left_flag )){letter_menu->left( );}
      else if(ctrl.test_pressing(Key::right_flag)){letter_menu->right();}
      else if(ctrl.test_pressing(Key::shift_flag))
        {
          auto  n = (int)letter_menu->get_charset();

          ++n;

            if(static_cast<LetterMenu::Charset>(n) == LetterMenu::Charset::END)
            {
              n = 0;
            }


          letter_menu->change_charset(static_cast<LetterMenu::Charset>(n));
        }

      else if(ctrl.test_pressing(Key::p_flag))
        {
          name_buffer.push_back(letter_menu->get_char());

          name_board_.set_string(name_buffer.data());
        }

      else if(ctrl.test_pressing(Key::n_flag) && name_buffer.size())
        {
          name_buffer.pop_back();

          name_board_.set_string(name_buffer.data());
        }

      else if(ctrl.test_pressing(Key::start_flag))
        {
          current_player->set_name(std::move(name_buffer));

          change_mode(Mode::manage);
        }


      set_flag(redraw_flag);

      key_timer = 0;
    }
}




